/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateCveIdsPartialResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveIdsPartialResponse{}

// CreateCveIdsPartialResponse struct for CreateCveIdsPartialResponse
type CreateCveIdsPartialResponse struct {
	Error *string `json:"error,omitempty"`
	Message *string `json:"message,omitempty"`
	Details *CreateCveIdsPartialResponseDetails `json:"details,omitempty"`
	CveIds []CreateCveIdsPartialResponseCveIdsInner `json:"cve_ids,omitempty"`
}

// NewCreateCveIdsPartialResponse instantiates a new CreateCveIdsPartialResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveIdsPartialResponse() *CreateCveIdsPartialResponse {
	this := CreateCveIdsPartialResponse{}
	return &this
}

// NewCreateCveIdsPartialResponseWithDefaults instantiates a new CreateCveIdsPartialResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveIdsPartialResponseWithDefaults() *CreateCveIdsPartialResponse {
	this := CreateCveIdsPartialResponse{}
	return &this
}

// GetError returns the Error field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponse) GetError() string {
	if o == nil || IsNil(o.Error) {
		var ret string
		return ret
	}
	return *o.Error
}

// GetErrorOk returns a tuple with the Error field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponse) GetErrorOk() (*string, bool) {
	if o == nil || IsNil(o.Error) {
		return nil, false
	}
	return o.Error, true
}

// HasError returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponse) HasError() bool {
	if o != nil && !IsNil(o.Error) {
		return true
	}

	return false
}

// SetError gets a reference to the given string and assigns it to the Error field.
func (o *CreateCveIdsPartialResponse) SetError(v string) {
	o.Error = &v
}

// GetMessage returns the Message field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponse) GetMessage() string {
	if o == nil || IsNil(o.Message) {
		var ret string
		return ret
	}
	return *o.Message
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponse) GetMessageOk() (*string, bool) {
	if o == nil || IsNil(o.Message) {
		return nil, false
	}
	return o.Message, true
}

// HasMessage returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponse) HasMessage() bool {
	if o != nil && !IsNil(o.Message) {
		return true
	}

	return false
}

// SetMessage gets a reference to the given string and assigns it to the Message field.
func (o *CreateCveIdsPartialResponse) SetMessage(v string) {
	o.Message = &v
}

// GetDetails returns the Details field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponse) GetDetails() CreateCveIdsPartialResponseDetails {
	if o == nil || IsNil(o.Details) {
		var ret CreateCveIdsPartialResponseDetails
		return ret
	}
	return *o.Details
}

// GetDetailsOk returns a tuple with the Details field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponse) GetDetailsOk() (*CreateCveIdsPartialResponseDetails, bool) {
	if o == nil || IsNil(o.Details) {
		return nil, false
	}
	return o.Details, true
}

// HasDetails returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponse) HasDetails() bool {
	if o != nil && !IsNil(o.Details) {
		return true
	}

	return false
}

// SetDetails gets a reference to the given CreateCveIdsPartialResponseDetails and assigns it to the Details field.
func (o *CreateCveIdsPartialResponse) SetDetails(v CreateCveIdsPartialResponseDetails) {
	o.Details = &v
}

// GetCveIds returns the CveIds field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponse) GetCveIds() []CreateCveIdsPartialResponseCveIdsInner {
	if o == nil || IsNil(o.CveIds) {
		var ret []CreateCveIdsPartialResponseCveIdsInner
		return ret
	}
	return o.CveIds
}

// GetCveIdsOk returns a tuple with the CveIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponse) GetCveIdsOk() ([]CreateCveIdsPartialResponseCveIdsInner, bool) {
	if o == nil || IsNil(o.CveIds) {
		return nil, false
	}
	return o.CveIds, true
}

// HasCveIds returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponse) HasCveIds() bool {
	if o != nil && !IsNil(o.CveIds) {
		return true
	}

	return false
}

// SetCveIds gets a reference to the given []CreateCveIdsPartialResponseCveIdsInner and assigns it to the CveIds field.
func (o *CreateCveIdsPartialResponse) SetCveIds(v []CreateCveIdsPartialResponseCveIdsInner) {
	o.CveIds = v
}

func (o CreateCveIdsPartialResponse) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveIdsPartialResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Error) {
		toSerialize["error"] = o.Error
	}
	if !IsNil(o.Message) {
		toSerialize["message"] = o.Message
	}
	if !IsNil(o.Details) {
		toSerialize["details"] = o.Details
	}
	if !IsNil(o.CveIds) {
		toSerialize["cve_ids"] = o.CveIds
	}
	return toSerialize, nil
}

type NullableCreateCveIdsPartialResponse struct {
	value *CreateCveIdsPartialResponse
	isSet bool
}

func (v NullableCreateCveIdsPartialResponse) Get() *CreateCveIdsPartialResponse {
	return v.value
}

func (v *NullableCreateCveIdsPartialResponse) Set(val *CreateCveIdsPartialResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveIdsPartialResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveIdsPartialResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveIdsPartialResponse(val *CreateCveIdsPartialResponse) *NullableCreateCveIdsPartialResponse {
	return &NullableCreateCveIdsPartialResponse{value: val, isSet: true}
}

func (v NullableCreateCveIdsPartialResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveIdsPartialResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


